
proc add_import_menu_item { label command } {

    .mbar.file.menu.import add command -label $label -command $command
}

proc add_export_menu_item { label command } {

    .mbar.file.menu.export add command -label $label -command $command
}

proc add_tools_menu_item { label command help } {
global balloon_menu_help

    .mbar.tools.menu add command -label $label -command $command
    set balloon_menu_help(.mbar.tools.menu) [concat $balloon_menu_help(.mbar.tools.menu) "{ $help }"]
}

proc add_surface_menu_item { label command help} {
global balloon_menu_help

    .mbar.surface.menu add command -label $label -command $command
    set balloon_menu_help(.mbar.surface.menu) [concat $balloon_menu_help(.mbar.surface.menu) "{ $help }"]
}





proc get_ac3d_path { name } {
global prefs_plugin_dir
global AC3D_HOME

    if { $name == "plugins" } {
        return [eval "set temp $prefs_plugin_dir"]
    }
    return name
}




proc load_plugins { } {

set path [get_ac3d_path plugins]

    set oldd [pwd]
    set e [ catch { cd $path} ]

    if { $e } {
        puts "can't change to plugin dir '$path'"
    } else {
        set pwd [pwd]
        set plist ""
        catch { set plist [ glob *.p] }
puts $plist
        foreach p $plist {
            ac3d plugin_load "$path/$p"
            }
    }
    cd $oldd
}






























