
# some tcl code to make the frames resizeable
# very flickery but it works

proc frame_press { win } {
global viewsetting 
global prefs_window_3d_width_percent
global prefs_window_3d_height_percent
global frame_move_horiz
global frame_move_vert

    if { $viewsetting != "all" } { return }

set col white
.views.xyframe configure -bg $col
.views.zyframe configure -bg $col
.views.xzframe configure -bg $col
.views.xyzframe configure -bg $col


    set rx [winfo rootx .views]
    set ry [winfo rooty .views]
    set x [winfo pointerx $win]
    set y [winfo pointery $win]
    set xd [expr $x-$rx]
    set yd [expr $y-$ry]

    set w [winfo width .views]
    set h [winfo height .views ]

    set w2 [expr 100 - int (($xd.0/$w.0) *100)]
    set h2 [expr 100 - int (($yd.0/$h.0) *100)]

    set ha [expr abs( $prefs_window_3d_width_percent - $w2) ]
    set va [expr abs( $prefs_window_3d_height_percent - $h2) ]

    set frame_move_horiz false
    set frame_move_vert false


    if { ( $ha < 5 ) && ($va < 5) } {
        set frame_move_horiz true
        set frame_move_vert true
    } elseif { ($ha < 5) } {
        set frame_move_horiz true
    } elseif { ($va < 5) } {
        set frame_move_vert true
    }
}

proc frame_drag {win} {
global prefs_window_3d_width_percent
global prefs_window_3d_height_percent
global viewsetting 
global frame_move_horiz
global frame_move_vert

    if { $viewsetting != "all" } { return }

    set rx [winfo rootx .views]
    set ry [winfo rooty .views]
    set x [winfo pointerx $win]
    set y [winfo pointery $win]
    set xd [expr $x-$rx]
    set yd [expr $y-$ry]

    set w [winfo width .views]
    set h [winfo height .views ]

    set w2 [expr 100 - int (($xd.0/$w.0) *100)]
    set h2 [expr 100 - int (($yd.0/$h.0) *100)]

    if { ($w2 > 5) && ($w2 < 95) } {
        if { ($frame_move_horiz) } {
            set prefs_window_3d_width_percent $w2
        }
    }
    if { ($h2 > 5) && ($h2 < 95) } {
        if { $frame_move_vert } {
            set prefs_window_3d_height_percent $h2
        }
    }

    configure_views
}

proc frame_release {win} {

set col grey
.views.xyframe configure -bg $col
.views.zyframe configure -bg $col
.views.xzframe configure -bg $col
.views.xyzframe configure -bg $col

}


proc bind_frame_resize {} {

bind .views.xyframe <1> { frame_press %W }
bind .views.zyframe <1> { frame_press %W }
bind .views.xzframe <1> { frame_press %W }
bind .views.xyzframe <1> { frame_press %W }

bind .views.xyframe <B1-Motion> { frame_drag %W }
bind .views.zyframe <B1-Motion> { frame_drag %W }
bind .views.xzframe <B1-Motion> { frame_drag %W }
bind .views.xyzframe <B1-Motion> { frame_drag %W }

bind .views.xyframe <ButtonRelease-1> { frame_release %W }
bind .views.zyframe <ButtonRelease-1> { frame_release %W }
bind .views.xzframe <ButtonRelease-1> { frame_release %W }
bind .views.xyzframe <ButtonRelease-1> { frame_release %W }

}


proc configure_views {} {
global viewsetting
global prefs_window_3d_width_percent
global prefs_window_3d_height_percent

    set w [winfo width .views]
    set h [winfo height .views ]
    set w2 [expr $w/2]
    set h2 [expr $h/2]


   set w3 [expr ($w/100.0)*$prefs_window_3d_width_percent]
   set h3 [expr ($h/100.0)*$prefs_window_3d_height_percent]
   set fw [expr $w-$w3]
   set fh [expr $h-$h3]

    switch $viewsetting {
        "all" {
            .views itemconfigure xy -width $fw -height $fh  
            .views coords xy 0 0

            .views itemconfigure zy -width $w3 -height $fh
            .views coords zy $fw 0

            .views itemconfigure xz -width $fw -height $h3
            .views coords xz 0 $fh

            .views itemconfigure xyz -width $w3 -height $h3 
            .views coords xyz $fw $fh
         }
       "xy" {
            .views coords xy 0 0 
            .views coords zy 5000 5000 
            .views coords xz 5000 5000 
            .views coords xyz 5000 5000 
            .views itemconfigure xy -width $w -height $h
        }
       "zy" {
            .views coords zy 0 0 
            .views coords xy 5000 5000 
            .views coords xz 5000 5000 
            .views coords xyz 5000 5000 
            .views itemconfigure zy -width $w -height $h
        }
       "xz" {
            .views coords xz 0 0 
            .views coords zy 5000 5000 
            .views coords xy 5000 5000 
            .views coords xyz 5000 5000 
            .views itemconfigure xz -width $w -height $h
        }
       "xyz" {
            .views coords xyz 0 0 
            .views coords zy 5000 5000 
            .views coords xy 5000 5000 
            .views coords xy 5000 5000 
            .views itemconfigure xyz -width $w -height $h
        }
    }

}







proc make_views {} {
global viewsetting

set frame(xy) [frame .views.xyframe -bd 2 -relief sunken]

frame $frame(xy).f 
pack $frame(xy).f  -fill both -expand 1
togl $frame(xy).f.win -rgba true -double true -depth true
pack $frame(xy).f.win  -fill both -expand 1


frame .views.zyframe -bd 2 -relief sunken
frame .views.zyframe.f 
pack .views.zyframe.f  -fill both -expand 1
togl .views.zyframe.f.win -rgba true -double true -depth true
pack .views.zyframe.f.win  -fill both -expand 1



frame .views.xzframe  -bd 2 -relief sunken
frame .views.xzframe.f 
pack .views.xzframe.f  -fill both -expand 1
togl .views.xzframe.f.win -rgba true -double true -depth true
pack .views.xzframe.f.win  -fill both -expand 1



frame .views.xyzframe -bd 2 -relief sunken
frame .views.xyzframe.f 
pack .views.xyzframe.f  -fill both -expand 1
togl .views.xyzframe.f.win -rgba true -double true -depth true
pack .views.xyzframe.f.win  -fill both -expand 1

        bind $frame(xy) <Enter> {focus .}
        bind .views.zyframe <Enter> {focus .}
        bind .views.xzframe <Enter> {focus .}
        bind .views.xyzframe <Enter> {focus .}




set viewsetting all


.views create window 0 0 -anchor nw -window $frame(xy) -tags xy
.views create window 400 0 -window .views.zyframe -anchor nw -tags zy
.views create window 0 400 -window .views.xzframe -anchor nw -tags xz 
.views create window 400 400  -window .views.xyzframe -anchor nw -tags xyz

bind .views <Configure> { configure_views }


bind_frame_resize
}


